/* PRO-SCAMS "@@(#) xfer.c, Rev: 1.4.0.0" */


/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.0                                        12/05/93 */
/*                                                                      */
/* AUTHOR: William C. Brown                                             */
/* VERSION: 1.0 (beta)                                                  */
/* DESCRIPTION: To provide a nice X based dialer interface that works   */
/*              in conjunction with the connection server in SVR4.2.    */
/*                                                                      */
/* -------------------------------------------------------------------- */
/* Notes: Transfer files popup.						*/
/*                                                                      */
/*                                                                ----- */


#include <stdio.h>
#include <termios.h>
#include <dial.h>
#include <signal.h>
#include <fcntl.h>
#include <stropts.h>
#include <poll.h>
#include <errno.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/Caption.h>
#include <Xol/OpenLook.h>
#include <Xol/Form.h>
#include <Xol/FButtons.h>
#include <Xol/TextField.h>
#include <Xol/StaticText.h>
#include <Xol/ScrollingL.h>

#include "uwdialer.h"

void Reap_Child();

Widget XferTop, XferTe1, XferTe2;
int Xfer_Protocol;

static String   Proto_Fields[] = {XtNlabel, XtNselectProc, XtNclientData};
static XtArgVal Proto_Items[] =
         {(XtArgVal)"Ascii",   (XtArgVal)Set_Protocol, (XtArgVal)ASCII,
          (XtArgVal)"Xmodem",  (XtArgVal)Set_Protocol, (XtArgVal)XMODEM,
          (XtArgVal)"Ymodem",  (XtArgVal)Set_Protocol, (XtArgVal)YMODEM,
          (XtArgVal)"Zmodem",  (XtArgVal)Set_Protocol, (XtArgVal)ZMODEM};


static String   Xfer_Fields[] = {XtNlabel, XtNselectProc};
static XtArgVal Xfer_Items[] =
         {(XtArgVal)"Start Transfer",  (XtArgVal)Start_Xfer};

static String   Dismiss_Fields[] = {XtNlabel, XtNselectProc};
static XtArgVal Dismiss_Items[] =
         {(XtArgVal)"Dismiss",  (XtArgVal)Drop_Xfer};

#define	PROTO_NUM	4

void Xfer_Popup(int Direction)
{
        int AC = 0;
        Arg args[20];
        Widget Form, Cap1, Cap2, Cap3, Bu1, Bu2, Invis, Protocol;
        extern Widget TopLevel;
	extern int Modem_fd;
	extern int Xfer_Direction;

	if(Modem_fd == 0) {
		(void)DialerError(NONFATAL, NOTCONNECTED);
		return;
	}

	Xfer_Direction = Direction;

        AC = 0;
        XtSetArg(args[AC], XtNtitle, "Transfer Popup");   AC++;
        XtSetArg(args[AC], XtNresizeCorners, FALSE);      AC++;
        XferTop = XtAppCreateShell("uwdialer", "UWdialer",
                        applicationShellWidgetClass, XtDisplay(TopLevel),
                        args, AC);
        AC = 0;
        Form = XtCreateManagedWidget ("form", formWidgetClass,
                                      XferTop, NULL, 0);

	AC = 0;
        XtSetArg(args[AC], XtNlabel, "Transfer Protocol:");  AC++;
        XtSetArg(args[AC], XtNyRefWidget, Form);             AC++;
        XtSetArg(args[AC], XtNyOffset, 15);                  AC++;
        XtSetArg(args[AC], XtNxRefWidget, Form);             AC++;
        XtSetArg(args[AC], XtNxOffset, 15);                  AC++;
        Cap1 = XtCreateManagedWidget ("cap1", captionWidgetClass,
                                        Form, args, AC);

	AC = 0;
        XtSetArg(args[AC], XtNbuttonType, OL_RECT_BTN);                AC++;
        XtSetArg(args[AC], XtNexclusives, True);                       AC++;
        XtSetArg(args[AC], XtNnoneSet, True);                          AC++;
        XtSetArg(args[AC], XtNitemFields, Proto_Fields);               AC++;
        XtSetArg(args[AC], XtNnumItemFields, XtNumber(Proto_Fields));  AC++;
        XtSetArg(args[AC], XtNitems, Proto_Items);                     AC++;
        XtSetArg(args[AC], XtNlayoutType, OL_FIXEDROWS);               AC++;
        XtSetArg(args[AC], XtNmeasure, 1);                             AC++;
        XtSetArg(args[AC], XtNnumItems, PROTO_NUM);                    AC++;
        Protocol = XtCreateManagedWidget ("excl", flatButtonsWidgetClass,
                                          Cap1, args, AC);

	AC = 0;
	if(Direction == UPLOAD) {
        	XtSetArg(args[AC], XtNlabel, "Source file:");  AC++;
	}
	else {
        	XtSetArg(args[AC], XtNlabel, "Target file:");  AC++;
	}
        XtSetArg(args[AC], XtNyRefWidget, Cap1); AC++;
        XtSetArg(args[AC], XtNxRefWidget, Form); AC++;
        XtSetArg(args[AC], XtNyAddHeight, True); AC++;
        XtSetArg(args[AC], XtNyOffset, 15);      AC++;
        XtSetArg(args[AC], XtNxOffset, 15);      AC++;
        Cap2 = XtCreateManagedWidget ("cap2", captionWidgetClass,
                                        Form, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNmaximumSize, 64);    AC++;
        XtSetArg(args[AC], XtNcharsVisible, 64);   AC++;
        XferTe1 = XtCreateManagedWidget ("te", textFieldWidgetClass,
                                        Cap2, args, AC);

	AC = 0;
        XtSetArg(args[AC], XtNlabel, "Command:"); AC++;
        XtSetArg(args[AC], XtNyRefWidget, Cap2);  AC++;
        XtSetArg(args[AC], XtNxRefWidget, Form);  AC++;
        XtSetArg(args[AC], XtNyAddHeight, True);  AC++;
        XtSetArg(args[AC], XtNyOffset, 15);       AC++;
        XtSetArg(args[AC], XtNxOffset, 15);       AC++;
        Cap3 = XtCreateManagedWidget ("cap3", captionWidgetClass,
                                        Form, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNmaximumSize, 64);    AC++;
        XtSetArg(args[AC], XtNcharsVisible, 64);   AC++;
        XferTe2 = XtCreateManagedWidget ("te", textFieldWidgetClass,
                                        Cap3, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNbuttonType, OL_OBLONG_BTN);             AC++;
        XtSetArg(args[AC], XtNitemFields, Xfer_Fields);               AC++;
        XtSetArg(args[AC], XtNnumItemFields, XtNumber(Xfer_Fields));  AC++;
        XtSetArg(args[AC], XtNclientData, XferTop);                   AC++;
        XtSetArg(args[AC], XtNitems, Xfer_Items);                     AC++;
        XtSetArg(args[AC], XtNlayoutType, OL_FIXEDROWS);              AC++;
        XtSetArg(args[AC], XtNmeasure, 1);                            AC++;
        XtSetArg(args[AC], XtNnumItems, 1);                           AC++;
        XtSetArg(args[AC], XtNyRefWidget, Cap3);                      AC++;
        XtSetArg(args[AC], XtNyOffset, 15);                           AC++;
        XtSetArg(args[AC], XtNyAddHeight, True);                      AC++;
        XtSetArg(args[AC], XtNxRefName, "form");                      AC++;
        XtSetArg(args[AC], XtNxOffset, 50);                           AC++;
        Bu1 = XtCreateManagedWidget ("bu", flatButtonsWidgetClass,
                                     Form, args, AC);

        AC = 0;
        XtSetArg(args[AC], XtNbuttonType, OL_OBLONG_BTN);                AC++;
        XtSetArg(args[AC], XtNitemFields, Dismiss_Fields);               AC++;
        XtSetArg(args[AC], XtNnumItemFields, XtNumber(Dismiss_Fields));  AC++;
        XtSetArg(args[AC], XtNclientData, XferTop);                      AC++;
        XtSetArg(args[AC], XtNitems, Dismiss_Items);                     AC++;
        XtSetArg(args[AC], XtNlayoutType, OL_FIXEDROWS);                 AC++;
        XtSetArg(args[AC], XtNmeasure, 1);                               AC++;
        XtSetArg(args[AC], XtNnumItems, 1);                              AC++;
        XtSetArg(args[AC], XtNyRefWidget, Bu1);                          AC++;
        XtSetArg(args[AC], XtNyOffset, 0);                               AC++;
        XtSetArg(args[AC], XtNxRefName, "form");                         AC++;
        XtSetArg(args[AC], XtNxAttachRight, TRUE);                       AC++;
        XtSetArg(args[AC], XtNxVaryOffset, TRUE);                        AC++;
        XtSetArg(args[AC], XtNxAttachOffset, 50);                        AC++;
        Bu2 = XtCreateManagedWidget ("bu", flatButtonsWidgetClass,
                                     Form, args, AC);
        AC = 0;
        XtSetArg(args[AC], XtNstring, "   ");    AC++;
        XtSetArg(args[AC], XtNyRefWidget, Bu2);  AC++;
        XtSetArg(args[AC], XtNyOffset, 0);       AC++;
        XtSetArg(args[AC], XtNyAddHeight, TRUE); AC++;
        Invis = XtCreateManagedWidget ("se", staticTextWidgetClass,
                                        Form, args, AC);

	XtRealizeWidget(XferTop);
} /* Xfer_Popup */

void Set_Protocol(Widget W, XtPointer ClientData, XtPointer CallData)
{
	if((int)ClientData == ASCII) 
		(void)Show_AsciiProtocol();
	else if((int)ClientData == XMODEM)
		(void)Show_XmodemProtocol();
	else if((int)ClientData == YMODEM)
		(void)Show_YmodemProtocol();
	else if((int)ClientData == ZMODEM)
		(void)Show_ZmodemProtocol();
} /* Set_Protocol */

void Show_AsciiProtocol()
{
	Arg args[1];
	char Temp[BUFSIZ];
	extern int Xfer_Direction;
	extern int Xfer_Protocol;

	if(Xfer_Direction == UPLOAD)
		(void)strcpy(Temp, "internal read < ${SOURCE_FILE}");
	else
		(void)strcpy(Temp, "internal function > ${TARGET_FILE}");

	Xfer_Protocol = ASCII;

	XtSetArg(args[0], XtNstring, Temp);
	XtSetValues(XferTe2, args, 1);
} /* Show_AsciiProtocol */

void Show_XmodemProtocol()
{
	Arg args[1];
	char *Temp;
	extern int Xfer_Direction;
	extern int Xfer_Protocol;
	extern Widget TopLevel;
	extern char *ProgName;

	if(Xfer_Direction == UPLOAD) {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "xmodemtransmit");
	}
	else {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "xmodemreceive");
	}

	Xfer_Protocol = XMODEM;

	XtSetArg(args[0], XtNstring, Temp);
	XtSetValues(XferTe2, args, 1);
} /* Show-XmodemProtocol */

void Show_YmodemProtocol()
{
	Arg args[1];
	char *Temp;
	extern int Xfer_Direction;
	extern int Xfer_Protocol;
	extern Widget TopLevel;
	extern char *ProgName;

	if(Xfer_Direction == UPLOAD) {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "ymodemtransmit");
	}
	else {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "ymodemreceive");
	}

	Xfer_Protocol = YMODEM;

	XtSetArg(args[0], XtNstring, Temp);
	XtSetValues(XferTe2, args, 1);
} /* Show_YmodemProtocol */

void Show_ZmodemProtocol()
{
	Arg args[1];
	char *Temp;
	extern int Xfer_Direction;
	extern int Xfer_Protocol;
	extern Widget TopLevel;
	extern char *ProgName;

	if(Xfer_Direction == UPLOAD) {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "zmodemtransmit");
	}
	else {
	        Temp = XGetDefault(XtDisplay(TopLevel), ProgName,
			 "zmodemreceive");
	}

	Xfer_Protocol = ZMODEM;

	XtSetArg(args[0], XtNstring, Temp);
	XtSetValues(XferTe2, args, 1);
} /* Show_ZmodemProtocol */

void Start_Xfer(Widget W, XtPointer ClientData, XtPointer CallData)
{
	Arg args[1];
	char Temp[BUFSIZ];
	char Replace[25];
	char *Command;
	char *File;
	char *Suffix;
	char *ptr1, *ptr2;
	struct sigaction sig;
	extern int Xfer_Direction;
	extern int Modem_fd;
	extern int Uid, Gid;
	extern Boolean Xfer_InProgress;

	XtSetArg(args[0], XtNstring, &File);
	XtGetValues(XferTe1, args, 1);
	XtSetArg(args[0], XtNstring, &Command);
	XtGetValues(XferTe2, args, 1);

	if(strlen(File) == 0) {
		(void)DialerError(NONFATAL, NOFILESPECIFIED);
		return;
	}

	if(Xfer_Direction == UPLOAD) 
		(void)strcpy(Replace, "${SOURCE_FILE}");
	else
		(void)strcpy(Replace, "${TARGET_FILE}");

	(void)memset(Temp, NULL, BUFSIZ);
	for(ptr1=Command,ptr2=Temp;*ptr1!=NULL;ptr1++) {
		if(strncmp(ptr1, Replace, strlen(Replace)) == 0) {
			(void)strcat(ptr2, File);
			ptr1 = ptr1 + (strlen(Replace) - 1);
			ptr2 = ptr2 + strlen(File);
			continue;
		}
		*ptr2++ = *ptr1;
	} /* for */

	/* -----					*/
	/* Start a child process to handle the transfer */
	/*					  ----- */

	switch(fork()) {
		case 0:
			(void)sleep(1);
			(void)close(0);
			(void)close(1);
			(void)dup(Modem_fd);
			(void)dup(Modem_fd);
			if((Xfer_Protocol == ASCII) &&
		           (Xfer_Direction == DOWNLOAD)) {
				(void)setuid(Uid);
				(void)setgid(Gid);
				(void)Receive_Ascii_File(File);
			}
			else if((Xfer_Protocol == ASCII) &&
		                (Xfer_Direction == UPLOAD)) {
				(void)setuid(Uid);
				(void)setgid(Gid);
				(void)Transmit_Ascii_File(File);
			}
			else {
				(void)execlp("sh", "sh", "-c", Temp, 0);
				(void)DialerError(FATAL, CANTCREATECHILD);
			}
			(void)tcflush(fileno(stdout), TCOFLUSH);
			exit(0);
		case -1:
			(void)DialerError(FATAL, CANTCREATECHILD);
			break;
		default:
			Xfer_InProgress = True;
			sig.sa_handler = Reap_Child;
			sig.sa_flags = 0;
			sig.sa_flags |= SA_RESTART;
			sigaction(SIGCHLD, &sig, NULL);
			(void)Update_Display_Xfer(Xfer_Direction);
	}

	(void)Drop_Xfer(NULL, (XtPointer)XferTop, NULL);

} /* Start_Xfer */

void Drop_Xfer(Widget W, XtPointer ClientData, XtPointer CallData)
{
	extern int Xfer_Direction;
	extern Boolean Xfer_InProgress;
	extern int Xtermid;

	XtDestroyWidget(ClientData);
	if(Xfer_InProgress == False)
		Xfer_Direction = 0;

	(void)Call_Enter(NULL, Xtermid, NULL, NULL);
} /* Start_Xfer */

void Reap_Child()
{
	int stat;
	extern int Xfer_Direction;
	extern Boolean Xfer_InProgress;
	extern int Xtermid;

	(void)wait(&stat);

	(void)Update_Display_Xfer(Xfer_Direction);
	(void)Call_Enter(NULL, Xtermid, NULL, NULL);
	Xfer_Direction = 0;
	Xfer_InProgress = False;
} /* Reap_Child() */

void Receive_Ascii_File(char *file)
{
	int fd;
	int pollret, nbytes;
	int count = 0;
	int TimeOut = -1;
	char Buffer[BUFSIZ];
	char *ptr;
	struct pollfd pfds[1];

	pfds->fd = fileno(stdin);
	pfds->events = POLLIN;

	if((fd = open(file, O_WRONLY|O_CREAT, 0666)) < 0) {
		(void)DialerError(NONFATAL, ASCIIDOWNLOAD, file);
		return;
	}

	while((pollret = poll(pfds, 1, TimeOut)) >= 0) {
		if(pollret == 0) {
			if(count++ == 2)
				break;
		}

		if(pfds->revents & POLLIN) {
			TimeOut = 1000;
			(void)memset(Buffer, NULL, BUFSIZ);
			if((nbytes = read(pfds->fd, Buffer, BUFSIZ)) > 0) {
				ptr = Strip(Buffer);
                		(void)write(fd, ptr, strlen(ptr));
			}
		}
	}

	(void)close(fd);
	exit(0);
} /* Receive_Ascii_File */

void Transmit_Ascii_File(char *file)
{
	int fd, nbytes;
	char Buffer[BUFSIZ];

	if((fd = open(file, O_RDONLY)) < 0) {
		(void)DialerError(NONFATAL, ASCIIUPLOAD, file);
		return;
	}

	while((nbytes = read(fd, Buffer, BUFSIZ)) > 0) {
		(void)write(fileno(stdout), Buffer, nbytes);
	}
	(void)write(fileno(stdout), '\r', 1);
	(void)tcdrain(fileno(stdout));
	(void)close(fd);

} /* Transmit_Ascii_File */
